package com.dvp.tutoriel.fibonacci;

import java.util.HashMap;
import java.util.Map;

public class MaCalculette implements Calculette {

	private static Map<Integer, Long> map = new HashMap<Integer, Long>();

	private final static double NOMBRE_OR = 1.61803398874989;
	private final static double RACINE_5 = 2.236067977499;

	public Long fibonacciAvecNombreOr(Integer n) {
		// REGLE RG024.4
		if (n <= 0) {
			throw new IllegalArgumentException("On ne calcule que pour des nombres positifs");
		}

		// REGLE RG024.1 : f(1) = 1
		// REGLE RG024.2 : f(2) = 1
		if (n == 1 || n == 2) {
			return 1L;
		}

		final double nominateur = Math.pow(NOMBRE_OR, n);

		final double result = nominateur / RACINE_5;
		return Math.round(result);
	}

	@Override
	public Long fibonacci(Integer n) {

		// REGLE RG024.4
		if (n <= 0) {
			throw new IllegalArgumentException("On ne calcule que pour des nombres positifs");
		}

		// REGLE RG024.1 : f(1) = 1
		// REGLE RG024.2 : f(2) = 1
		if (n == 1 || n == 2) {
			return 1L;
		}

		// REGLE RG024.5
		// REGLE RG024.6
		Long valeur = map.get(n);
		if (valeur != null) {
			return valeur;
		}

		// REGLE RG024.3.x
		valeur = fibonacci(n - 1) + fibonacci(n - 2);
		map.put(n, valeur);
		return valeur;

	}

}
